import java.io.*;
import javax.swing.*;
import javax.tools.*;
import java.util.*;
import java.lang.Integer;
import java.awt.*;
import java.awt.event.*;
import java.awt.font.*;
import java.awt.geom.*;
import java.awt.image.*;
import javax.swing.*;
import java.util.Locale;
import java.text.*;
import java.util.*;
import javax.swing.table.*;

class ce2 
{ 	 	
	 public ce2(double x1,double x2,String s) 
	 {     
        double a[]={x1,x2};
        double r;
        r= ikiyebolme(new fa(),a[0],a[1]);
        JOptionPane.showMessageDialog(null," kök değeri  : "+r,
        "f(x) = "+s,JOptionPane.PLAIN_MESSAGE);
     }

public static double ikiyebolme(f_x f,double a,double b)
{
//ikiye bölme yöntemi a ile b arsında kök değerini 
// her seferinde sayıyı ikiye bölerek arar.
double test;
double p=0;
double es,ea;
double fa,fp;
int maxit=500,iter=0;
es=0.0000001;
ea=1.1*es;
while((ea>es)&&(iter<maxit))
{
    p=(a+b)/2.0;
    iter++;
    if((a+b)!=0)
        { ea=Math.abs((b-a)/(a+b))*100;}
    fa= f.func(a);
    fp= f.func(p);
    test= fa*fp;
    if(test==0.0)      ea=0;
    else if(test<0.0)  b=p;
    else              {a=p;}
} 
if(iter>=maxit) JOptionPane.showMessageDialog(null,"Uyarı maximum iterasyon sayısı aşıldı \n"+
   " çözüm geçerli olmıyabilir","MAKSİMUM ITERASYON SAYISI UYARISI",JOptionPane.WARNING_MESSAGE); 
return p;
}
	  public static void main(String arg[])
	  { String s1=JOptionPane.showInputDialog(" Fonksiyonu giriniz : ");
		ce1 x0=new ce1(s1);
        double a[]=Text.readDoubleV("Fonksiyonun minimum ve maksimum değerlerini giriniz xmin xmax");
        ce3 x1=new ce3(a[0],a[1],100,x0.s);
        ce2 x2=new ce2(a[0],a[1],"kök bulma");
	  }
 }
